import linecache
import sys

class KeySqlExceptionMessage:
    STATEMENT_TYPE_NOT_STRING = "Statement type should be string"
    EMPTY_STATEMENT = "Empty statement"

    STATEMENT_TYPE_NOT_IMPLEMENTED = "Statement type is not implemented"
    STORE_IS_NOT_DEFINED = "Store is not defined"
    SCHEMA_IS_NOT_DEFINED = "Schema is not defined"
    ALTER_SCHEMA_HAS_NO_PATAMETERS = "ALTER SCHEMA statement has no pareameters"

    DATA_TYPE_IS_NOT_PROCESSED = "Data type is not processed"

    NO_KEYOBJECT_DEFINITION = "There is no keyobject definition"

    USED_user_name_0 = "USED_user_name_0 - can not clean catalogs"

    UNSIGNED_REPLY = '***UNSIGNED_REPLY***'

    WRONG_USER_PASSWORD_REPLY = 'Wrong username/password'

    STATEMENT_UNKNOWN = "Unknown StatementType"

    STATEMENT_STR_MISMATCH = "Number of parameters should be equal number of '{}' in statement"
    IMPROPER_END_OF_STATEMENT = "improper end of statement"

    CAN_NOT_DELETE_CATALOGS_FOR_DEFAULT_USER = "Can not delete catalogs for default user"

    # String queries
    STRING_QUERY_CAN_NOT_HAVE_COMMA = "String query can not include ', values should be inserted as parameters"
    NUMBER_PATTERNS_EQUALS_NUMBER_ARGUMENTS = "Number of patterns {} should be equal to number of arguments"
    PARAMETERIZED_ONE_QUERY_ONLY = "Parameters are available only for execution of one query only"

    SELECT_REPLY_SHOULD_START_WITH_CURLY_BRACKET = " Non-empty Select reply string should start with {"

    # Parsing parameters
    PARSING_UNKNOWN_TYPE = "Parsing unknown type"

    # Format message
    FORMAT_KEYSQL_JSON = "Format should be only 'keysql' or 'json'"
    FORMAT_KEYSQL_JSON_PACKED = "Format should be only 'keysql' or 'json' or 'packed'"

    WRONG_JSON_FORMAT = "Wrong JSON format"

    CAN_NOT_CHANGE_SCHEMA = "Can not change schema"

    ADMIN_PASSWORD_NOT_VALID = "Admin/password are not valid"

    # connections
    #ConnectionError
    ASYNC_CONNECTION_TYPE = "Async connection should be only 'async' or 'async_coroutine'"
    DISCONNECT_BEFORE_CONNECT = "Disconnect before calling function connect"
    SHUTDOWN_TCP_ONLY = "Server Shutdown can be done only for tcp connection (can not be done for ssl connection)"
    SERVER_TIMEOUT_EXCEPTION = "Server connection timeout"
    QUERY_TIMEOUT_EXCEPTION = "Query execution timeout"
    CONNECTION_LOST = "KeySql connection is lost"

    # instances
    INSTANCE_KEY_SCHEMA_NAME = "Instance key should be SCHEMA_NAME"
    INSTANCE_KEY_VERSION_INFO = "Instance key should be VERSION_INFO"

    # exception
    EXCEPTION_SHOULD_BE_RAISED = "Exception should be raised"



class KeySqlException(ValueError):
    def __init__(self, exit_code, reply):
        self.error_code = exit_code
        self.error_text = reply

    @staticmethod
    def print_exception_log(sys_exc_info):
        exc_type, exc_obj, tb = sys_exc_info  # sys.exc_info()
        f = tb.tb_frame
        lineno = tb.tb_lineno
        filename = f.f_code.co_filename
        linecache.checkcache(filename)
        line = linecache.getline(filename, lineno, f.f_globals)
        exc_message = 'EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj)
        print("=" * 80)
        print(exc_message)
        print("=" * 80)
        return exc_message



class KeySqlConnectException(ValueError):
    def __init__(self, reply = KeySqlExceptionMessage.WRONG_USER_PASSWORD_REPLY):
        self.error_text = reply

