from keysql_client.keysql_connector import *
from keysql_client.keysql_catalog_statement import *
from keysql_client.keysql_select import SelectStatement
from keysql_client.keysql_delete import DeleteStatement
from keysql_client.keysql_show_statement import KeySqlShowStoresStatement, KeySqlShowStoreStatement
from keysql_client.keysql_show_statement import KeySqlShowCatalogStatement, KeySqlShowCatalogsStatement
from keysql_client.keysql_store_statement import KeySqlDropStoreStatement, KeySqlDropStoresStatement
from keysql_client.keysql_store_statement import KeySqlAlterStoreNameStatement, KeySqlCreateStoreStatement
from keysql_client.keysql_store_statement import KeySqlTruncateStoreStatement
from keysql_client.keysql_schema_statement import KeySqlShowSchemasStatement, KeySqlCreateSchemaStatement,\
    KeySqlDropSchemaStatement, KeySqlAlterSchemaStatement
from keysql_client.keysql_update import UpdateStatement
from keysql_client.keysql_insert import InsertIntoStoreInstance
from keysql_client.key_object_statement import ShowKeyObjectStatement, DropKeyObjectStatement,\
    AlterKeyObjectStatement, CreateKeyObjectStatement
from keysql_client.keysql_users_statement import KeySqlShowUsersStatement
from keysql_client.keysql_grant_statement import KeySqlGrantStatement
from keysql_client.keysql_revoke_statement import KeySqlRevokeStatement
from keysql_client.keysql_permissions_statement import KeySqlPermissionsStatement
from keysql_client.keysql_statement_default import KeySqlDefaultStatement
from keysql_client.keysql_describe_statement import KeySqlDescribe

from keysql_client.keysql_exception import KeySqlException, KeySqlExceptionMessage

from keysql_client.keysql_statement_type_object import  StatementType, StatementObj

"""
examples:
statement_type = header['statement_type']
statement_obj = header['statement_obj'] 

# create catalog {}
# create keyobject {} in catalog
# create store {} in catalog {}

# show catalog {}
# show catalogs 
# show stores for catalog {}

# show schemas
# create schema {}
# drop schema {}
# alter schema {} = {}

# SHOW PERMISSIONS FOR USER {}
# SHOW PERMISSIONS                # current user

if statement_type == StatementType. 
"""

#example:
# header
# {'message_length': 0, 'user': -1, 'id': 2, 'command': 1, 'exit_code': 0, 'statement_type': <StatementType.SHOW: 3>,
# 'instance_count': 0, 'time': 0.000195, 'page': 0, 'format': 'keysql', 'statement_obj': <StatementObj.CATALOGS: 4>,
# 'err_message': ''}

class KeySqlReplyStatement:
    def __init__(self, header):
        self._statement_type = header['statement_type']
        self._statement_obj = header['statement_obj']

    def get_keysql_statement(self):
        if self._statement_type == StatementType.SHOW:
            if self._statement_obj == StatementObj.CATALOGS:
                return KeySqlShowCatalogsStatement()  # KeySqlDefaultStatement()  # KeySqlShowCatalogsStatement()
            if self._statement_obj == StatementObj.CATALOG:
                return KeySqlShowCatalogStatement()  # KeySqlDefaultStatement() #  KeySqlShowCatalogStatement()
            if self._statement_obj == StatementObj.STORES:
                return KeySqlShowStoresStatement()
            if self._statement_obj == StatementObj.STORE:
                return  KeySqlShowStoreStatement()
            if self._statement_obj == StatementObj.KEYOBJECT:
                return ShowKeyObjectStatement()

            if self._statement_obj == StatementObj.SCHEMAS:
                return KeySqlShowSchemasStatement()
            if self._statement_obj == StatementObj.USERS:
                return KeySqlShowUsersStatement()

            if self._statement_obj == StatementObj.PERMISSIONS:
                return KeySqlShowUsersStatement()

            if self._statement_obj == StatementObj.UNKNOWN:
                return KeySqlDefaultStatement()  # GenericStatement()
            # anything else
            if self._statement_obj == StatementObj.ANYTHING_ELSE_OBJ:
                return KeySqlDefaultStatement()  # GenericStatement()

            return KeySqlDefaultStatement()

        if self._statement_type == StatementType.DROP:
            if self._statement_obj == StatementObj.CATALOG:
                return KeySqlDropCatalogStatement()
            if self._statement_obj == StatementObj.STORE:
                return KeySqlDropStoreStatement()
            if self._statement_obj == StatementObj.STORES:
                return KeySqlDropStoresStatement()
            if self._statement_obj == StatementObj.KEYOBJECT:
                return DropKeyObjectStatement()

            if self._statement_obj == StatementObj.SCHEMA:
                return KeySqlDropSchemaStatement()

            if self._statement_obj == StatementObj.UNKNOWN:
                return KeySqlDefaultStatement()  # GenericStatement()

            # anything else
            return KeySqlDefaultStatement()

        if self._statement_type == StatementType.ALTER:
            if self._statement_obj == StatementObj.CATALOG:
                return KeySqlAlterCatalogStatement()
            if self._statement_obj == StatementObj.STORE:
                return KeySqlAlterStoreNameStatement()
            if self._statement_obj == StatementObj.KEYOBJECT:
                return AlterKeyObjectStatement()
            if self._statement_obj == StatementObj.SCHEMA:
                return KeySqlAlterSchemaStatement()

            if self._statement_obj == StatementObj.UNKNOWN:
                return KeySqlDefaultStatement()  # GenericStatement()

            # anything else
            return KeySqlDefaultStatement()

        if self._statement_type == StatementType.SELECT:
            return SelectStatement()

        if self._statement_type == StatementType.UPDATE:
            if self._statement_obj == StatementObj.STORE:
                return UpdateStatement()
            # anything else
            return KeySqlDefaultStatement()

        if self._statement_type == StatementType.INSERT:
            if self._statement_obj == StatementObj.STORE:
                return InsertIntoStoreInstance()

            if self._statement_obj == StatementObj.UNKNOWN:
                return KeySqlDefaultStatement()  # GenericStatement()

            # anything else
            return KeySqlDefaultStatement()

        if self._statement_type == StatementType.CREATE:
            if self._statement_obj == StatementObj.CATALOG:
                return KeySqlCreateCatalogStatement()
            if self._statement_obj == StatementObj.STORE:
                return KeySqlCreateStoreStatement()
            if self._statement_obj == StatementObj.KEYOBJECT:
                return CreateKeyObjectStatement()

            if self._statement_obj == StatementObj.SCHEMA:
                return KeySqlCreateSchemaStatement()

            if self._statement_obj == StatementObj.UNKNOWN:
                return KeySqlDefaultStatement()  # GenericStatement()

            # anything else
            return KeySqlDefaultStatement()

        if self._statement_type == StatementType.GRANT:
            if self._statement_obj == StatementObj.USER:
                return KeySqlGrantStatement()

            if self._statement_obj == StatementObj.UNKNOWN:
                return KeySqlDefaultStatement()  # GenericStatement()

        if self._statement_type == StatementType.DELETE:
            return DeleteStatement()

        # anything else
        #return KeySqlDefaultStatement()

        if self._statement_type == StatementType.REVOKE:
            if self._statement_obj == StatementObj.USER:
                return KeySqlRevokeStatement()

            if self._statement_obj == StatementObj.UNKNOWN:
                return KeySqlDefaultStatement()  # GenericStatement()

            # anything else
            return KeySqlDefaultStatement()

        if self._statement_type == StatementType.DELETE:
            return DeleteStatement()

        if self._statement_type == StatementType.TRUNCATE:
            return KeySqlTruncateStoreStatement()

        if self._statement_type == StatementType.DESCRIBE:
            return KeySqlDescribe()

        if self._statement_type == StatementType.ANYTHING_ELSE_ST:
            return KeySqlDefaultStatement()  # GenericStatement()

        if self._statement_type == StatementType.UNKNOWN:
            return KeySqlDefaultStatement()  # KeySqlDefaultStatement()  # GenericStatement()

        # raise KeySqlException(-1, KeySqlExceptionMessage.STATEMENT_UNKNOWN)
        # anything else
        return KeySqlDefaultStatement()

        #TODO  add all other statements (when new statements are available) !!!!!
        #return None

if __name__ == "__main__":
    header = {'message_length': 0, 'user': -1, 'id': 2, 'command': 1, 'exit_code': 0,
              'statement_type': StatementType.SHOW, 'instance_count': 0, 'time': 0.000195, 'page': 0,
                'format': 'keysql', 'statement_obj': StatementObj.CATALOGS, 'err_message': ''}

    reply = 't1,\nt2'
    statement_extractor = KeySqlReplyStatement(header)
    res = statement_extractor.get_keysql_statement()
    print(res)
    print(res.__dict__)
    print(type(res))
