#/**********************************************************************************
#* Copyright (C) 2017-2020 by KEYARK, INC. - All Rights Reserved.
#* All information contained herein is proprietary and confidential to KEYARK, INC.
#* Any use, reproduction, or disclosure without the written
#* permission of KEYARK, INC. is prohibited.
#* Written by Natalia Belyaeva <nbelyaeva@keyark.com>
#***********************************************************************************/
import logging
from typing import List
from keysql_client.keysql_statement import KeySqlStatement

class KeySqlUtil():
    """Useful utilites to work with KeySql instances
    """

    def __init__(self) -> None:
        pass

    @staticmethod
    def compare_instances(instance1, instance2):
        if not (instance1 and instance2 and type(instance1) == type(instance2)):
            return False
        if type(instance1) is List:
            if len(instance1) != len(instance2):
                return False
        return True

    @staticmethod
    def compare_results_of_instances(instance1_res, instance2_res):
        if instance1_res is None and instance2_res is None:
            return True

        if type(instance1_res) is List and type(instance2_res) is List:
            res1 = []
            for curr_inst in instance1_res:
                res1.append(curr_inst.serialize())

            res2 = []
            for curr_inst in instance2_res:
                res1.append(curr_inst.serialize())

            res1 = sorted(res1)
            res2 = sorted(res2)
        else:
            res1 = [instance1_res.serialize()]
            res2 = [instance2_res.serialize()]

        for i in range(len(res1)):
            if res1[i] != res2[i]:
                return False

        return True



if __name__ == "__main__":
    pass
